Unit Winamp;

Interface

Uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  DsgnIntf, ExtCtrls, IniFiles;

const
  WINAMP_CLOSE = 40001;
  WINAMP_BUTTON1 = 40044;
  WINAMP_BUTTON2 = 40045;
  WINAMP_BUTTON3 = 40046;
  WINAMP_BUTTON4 = 40047;
  WINAMP_BUTTON5 = 40048;
  WINAMP_EQ = 40036;
  WINAMP_PLAYLIST = 40040;
  WINAMP_VISIBLE = 40258;
  WINAMP_VOLUMEUP = 40058;
  WINAMP_VOLUMEDOWN = 40059;
  WINAMP_FFWD5S = 40060;
  WINAMP_REW5S = 40061;
  WINAMP_FADEOUTANDSTOP = 40147;
  WINAMP_STOPAFTERTHISSONG = 40157;
  WINAMP_IPC_DELETE = 101;
  WINAMP_IPC_PLAYFILE = 100;
  WINAMP_IPC_ISPLAYING = 104;
  WINAMP_IPC_STARTPLAY = 102;
  WINAMP_IPC_GETOUTPUTTIME = 105;
  WINAMP_IPC_JUMPTOTIME = 106;
  WINAMP_IPC_GETVERSION = 0;
  WINAMP_IPC_SETVOLUME = 122;
  WINAMP_IPC_SETPANNING = 123;
//version 1.0002
  WINAMP_IPC_GET_SHUFFLE = 250;
  WINAMP_IPC_GET_REPEAT = 251;
  WINAMP_IPC_SET_SHUFFLE = 252;
  WINAMP_IPC_SET_REPEAT = 253;
//end version 1.0002
//version 1.30
  WINAMP_IPC_GETINFO = 126;
  WINAMP_IPC_GETEQDATA = 127;
  WINAMP_IPC_SETEQDATA = 128;
//
Type
{For suport formats detect}
  In_mod = record
    Version: integer;
    Description: PChar;
    hMainWindow: LongWord;
    hDllInstance: LongWord;
    FileExtensions: PChar;
    {next don't need}
    Is_seekable: integer;
    UsesOutPutPlug: integer;
    Config: PChar;
    About: PChar;
    Init: PChar;
    Quit: PChar;
    GetFileInfo: PChar;
    InfoBox: PChar;
    IsOurFile: PChar;
    Play: PChar;
    Pause: PChar;
    UnPause: PChar;
    IsPaused: PChar;
    Stop: PChar;
    GetLength: PChar;
    GetOutPutTime: PChar;
    SetOutPutTime: PChar;
    SetVolume: PChar;
    SetPan: PChar;
    SAVSAInit: PChar;
    SAVSADeInit: PChar;
    SAAddPCMData: PChar;
    SAGetMode: PChar;
    SAAdd: PChar;
    VSAAddPCMData: PChar;
    VSAGetMode: PChar;
    VSAAdd: PChar;
    VSASetInfo: PChar;
    dsp_isactive: PChar;
    dsp_dosamples: PChar;
    EQSet: PChar;
    SetInfo: PChar;
    Out_Module: PChar;
  end;
  PIn_mod = ^In_mod;
//version 1.30
  //struct for GETINFO
    stFileInfo = record
      Samplerate: integer;
      Bitrate: integer;
      Channels: byte;
    end;
    PstFileInfo = ^stFileInfo;
  //end GETINFO
  //struct for EQ status
    stEQStatus = record
      EQ60Hz: byte;
      EQ170Hz: byte;
      EQ310Hz: byte;
      EQ600Hz: byte;
      EQ1KHz: byte;
      EQ3KHz: byte;
      EQ6KHz: byte;
      EQ12KHz: byte;
      EQ14KHz: byte;
      EQ16KHz: byte;
      EQPreamp: byte;
      EQEnabled: Boolean;
      EQAutoload: Boolean;
    end;
    PstEQStatus = ^stEQStatus;
  //end EQ status
//
// ver 1.35
  TEQEvent = procedure (newEQPos: stEQStatus) of object;
//
  TWinampStatus = (WAPlaying, WAPause, WAStop, WAUnknown);
  TWinamp = class(TComponent)
  private
	 { Private declarations }
	 FAbout : string;
	 FFileName : string;
	 FPath2WinAmp : string;
         FTimer: TTimer;
//version 1.20
         FVisible: Boolean;
//
         FOnStop: TNotifyEvent;
         FOnStart: TNotifyEvent;
         FOnPause: TNotifyEvent;
         FOnExit: TNotifyEvent;
//version 1.35
         FOnEQChange: TEQEvent;
//
	 procedure SetFileName(FileName : string);
	 procedure SetPosition(song_pos : integer);
//version 1.20
         procedure SetShuffle(AStatus: Boolean);
         procedure SetRepeat(AStatus: Boolean);
         function GetShuffle: Boolean;
         function GetRepeat: Boolean;
         procedure SetPlaylistEditor(AStatus: Boolean);
         procedure SetEqualizer(AStatus: Boolean);
         function GetPlaylistEditor: Boolean;
         function GetEqualizer: Boolean;
         procedure SetWAVisible(AStatus: Boolean);
         function GetWAVisible: Boolean;
//
//version 1.30
         function GetFileInfo: stFileInfo;
         function GetEQStatus: stEQStatus;
         procedure SetEQStatus(Value: stEQStatus);
//
	 function GetPosition : integer;
	 function GetLength : integer;
	 function GetStatus : TWinampStatus;
         procedure TimerExpired(Sender: TObject);
         function GetVersion: integer;
  protected
	 { Protected declarations }
  public
	 { Public declarations }
	 constructor Create(AOwner : TComponent); override;
         destructor Destroy; override;
//version 1.20
	 property SongPosition : integer read GetPosition write SetPosition;
         property Visible: Boolean read FVisible{GetWAVisible} write SetWAVisible;
         property WAShuffle: Boolean read GetShuffle write SetShuffle;
         property WARepeat: Boolean read GetRepeat write SetRepeat;
         property WAPlayListEditor: Boolean read GetPlayListEditor write SetPlayListEditor;
         property WAEqualizer: Boolean read GetEqualizer write SetEqualizer;
//
//version 1.30
         property FileInfo: stFileInfo read GetFileInfo;// write SetFileInfo;
         property EQStatus: stEQStatus read GetEQStatus write SetEQStatus;
//
  published
	 { Published declarations }
	 property About : string read FAbout write FAbout;
	 property FileName : string read FFileName write SetFileName;
	 property SongLength : integer read GetLength;
	 property WinampStatus : TWinampStatus read GetStatus;
	 property PathToWinAmp : string read FPath2WinAmp write FPath2WinAmp;
	 function StartWinAmp: Boolean;
	 procedure CloseWinAmp;
	 procedure Play;
	 procedure Pause;
	 procedure Stop;
         procedure OpenEQ;
         procedure VolumeUpByOne;
         procedure VolumeDownByOne;
         procedure SetVolume(Volume: byte);
         procedure SetPanning(Panning: byte);
         procedure JumpFWRDBy5sec;
         procedure JumpREWBy5sec;
         procedure FadeOutAndStop;
         procedure OpenPlayList;
//for compatibility
         procedure MakeVisible;
//
         function SupportFormats: PChar;
//version 1.35
         procedure ID3Tag;
//
         property OnStopPlay: TNotifyEvent read FOnStop write FOnStop;
         property OnStartPlay: TNotifyEvent read FOnStart write FOnStart;
         property OnPause: TNotifyEvent read FOnPause write FOnPause;
         property OnWinampExit: TNotifyEvent read FOnExit write FOnExit;
//version 1.35
         property OnEQChange: TEQEvent read FOnEQChange write FOnEQChange;
//
  end;


  TAboutProperty = class(TStringProperty)
  public
	 procedure Edit; override;
	 function GetAttributes: TPropertyAttributes; override;
  end;

  TWAPathProperty = class(TStringProperty)
  public
	 procedure Edit; override;
	 function GetAttributes: TPropertyAttributes; override;
  end;
//version 1.35
  TWAFileProperty = class(TStringProperty)
  public
	 procedure Edit; override;
	 function GetAttributes: TPropertyAttributes; override;
  end;
//

Procedure Register;

var
   hwnd_winamp: HWND;
   Status: TWinampStatus;
//ver 1.35
   eqst: stEQStatus;
//

Implementation

uses WAAboutDlg;

{ TWinamp }

Constructor TWinamp.Create(AOwner : TComponent);
begin
	Inherited Create(AOwner);
        FTimer:=TTimer.Create(Self);
        FTimer.Enabled:=False;
        FTimer.Interval:=1;
        Status:=WAStop;
        FTimer.OnTimer:=TimerExpired;
	FAbout:= 'About...';
        FVisible:=False;
end;

destructor TWinamp.Destroy;
begin
  FTimer.OnTimer:=nil;
  FOnStop:=nil;
  FOnStart:=nil;
  FOnPause:=nil;
  FTimer.Free;
  Inherited Destroy;
end;

function TWinamp.GetVersion: integer;
Begin
{	IPC_GETVERSION is sent to the window, and the return value is the version
		Version 1.55 = 0x1551
		Version 1.6b = 0x16A0
		Version 1.60 = 0x16AF
		Version 1.61 = 0x16B0
		Version 1.62 = 0x16B1
		Version 1.64 = 0x16B3
		Version 1.666 = 0x16B4
		Version 1.69 = 0x16B5
		Version 1.70 = 0x1700
		Version 1.72 = 0x1702
		Version 1.72 = 0x1703
		...
	the command_data parameter is 0.
	so,}
   Result:=SendMessage(hwnd_winamp,WM_USER,0,WINAMP_IPC_GETVERSION);
end;

function TWinamp.StartWinAmp: Boolean;
begin
   if not FileExists(FPath2Winamp) then
   begin
     Result:=False;
   end;
   WinExec(PChar(FPath2Winamp), SW_NORMAL{HIDE});
   hwnd_winamp:=FindWindow('Winamp v1.x',nil);
   if hwnd_winamp=0 then Result:=False
   else
   begin
     If FFileName<>'' then SetFileName(FFileName);
     eqst:=GetEQStatus;
     FTimer.Enabled:=True;
     Result:=True;
   end;
end;

procedure TWinamp.CloseWinAmp;
begin
  SendMessage(hwnd_winamp,WM_COMMAND,WINAMP_CLOSE,0);
  FTimer.Enabled:=False;
end;

procedure TWinamp.SetFileName(FileName : string);
var
  i: integer;
  cds: COPYDATASTRUCT;
begin
  FFileName:=FileName+#0;
  SendMessage(hwnd_winamp,WM_USER,0,WINAMP_IPC_DELETE);
  if GetVersion>=$1700 then
  begin
    cds.dwData:=WINAMP_IPC_PLAYFILE;
    cds.lpData:=PChar(FFileName);
    cds.cbData:=Length(FFileName);
    SendMessage(hwnd_winamp,WM_COPYDATA,0,integer(@cds));
  end
  else
  begin
    for i:=1 to Length(FFileName) do
      PostMessage(hwnd_winamp,WM_USER,ord(FFileName[i]),WINAMP_IPC_PLAYFILE);
  end;
end;

function TWinamp.GetLength : integer;
begin
  Result:=SendMessage(hwnd_winamp,WM_USER,1,WINAMP_IPC_GETOUTPUTTIME)*1000;
end;

function TWinamp.GetPosition : integer;
begin
  Result:=SendMessage(hwnd_winamp,WM_USER,0,WINAMP_IPC_GETOUTPUTTIME);
end;

procedure TWinamp.SetPosition(song_pos : integer);
begin
  SendMessage(hwnd_winamp,WM_USER,song_pos,WINAMP_IPC_JUMPTOTIME);
end;

function TWinamp.GetStatus : TWinampStatus;
begin
	Case SendMessage(hwnd_winamp,WM_USER,0,WINAMP_IPC_ISPLAYING) of
		1 : result:= WAPlaying;
		3 : result:= WAPause;
		0 : result:= WAStop;
	Else result:= WAUnknown;
	end;
end;

procedure TWinamp.Play;
begin
   PostMessage(hwnd_winamp,WM_USER,0,WINAMP_IPC_STARTPLAY);
   SendMessage(hwnd_winamp,WM_COMMAND,WINAMP_STOPAFTERTHISSONG,0);
end;

procedure TWinamp.Pause;
begin
   SendMessage(hwnd_winamp,WM_COMMAND,WINAMP_BUTTON2,0);
end;

procedure TWinamp.Stop;
begin
   SendMessage(hwnd_winamp,WM_COMMAND,WINAMP_BUTTON4,0);
end;

procedure TWinamp.OpenEQ;
begin
   SendMessage(hwnd_winamp,WM_COMMAND,WINAMP_EQ,0);
end;

procedure TWinamp.VolumeUpByOne;
begin
   SendMessage(hwnd_winamp,WM_COMMAND,WINAMP_VOLUMEUP,0);
end;

procedure TWinamp.VolumeDownByOne;
begin
   SendMessage(hwnd_winamp,WM_COMMAND,WINAMP_VOLUMEDOWN,0);
end;

procedure TWinamp.SetVolume(Volume: byte);
begin
  If GetVersion<$2000 then exit;
  SendMessage(hwnd_winamp,WM_USER,Volume,WINAMP_IPC_SETVOLUME);
end;

procedure TWinamp.SetPanning(Panning: byte);
begin
  If GetVersion<$2000 then exit;
  SendMessage(hwnd_winamp,WM_USER,Panning,WINAMP_IPC_SETPANNING);
end;

procedure TWinamp.JumpFWRDBy5sec;
begin
   SendMessage(hwnd_winamp,WM_COMMAND,WINAMP_FFWD5S,0);
end;

procedure TWinamp.JumpREWBy5sec;
begin
   SendMessage(hwnd_winamp,WM_COMMAND,WINAMP_REW5S,0);
end;

procedure TWinamp.FadeOutAndStop;
begin
   SendMessage(hwnd_winamp,WM_COMMAND,WINAMP_FADEOUTANDSTOP,0);
end;

procedure TWinamp.OpenPlayList;
begin
   SendMessage(hwnd_winamp,WM_COMMAND,WINAMP_PLAYLIST,0);
end;

procedure TWinamp.MakeVisible;
begin
//  if not IsWindowVisible(hwnd_winamp) then
//   SendMessage(hwnd_winamp,WM_COMMAND,WINAMP_VISIBLE,0);
   exit;
end;

//version 1.20
procedure TWinamp.SetShuffle(AStatus: Boolean);
begin
  If GetVersion<$2400 then exit;
  SendMessage(hwnd_winamp,WM_USER,ord(AStatus),WINAMP_IPC_SET_SHUFFLE);
end;

procedure TWinamp.SetRepeat(AStatus: Boolean);
begin
  If GetVersion<$2400 then exit;
  SendMessage(hwnd_winamp,WM_USER,ord(AStatus),WINAMP_IPC_SET_REPEAT);
end;

function TWinamp.GetShuffle: Boolean;
begin
  Result:=False;
  If GetVersion<$2400 then exit;
  Result:=Boolean(SendMessage(hwnd_winamp,WM_USER,0,WINAMP_IPC_GET_SHUFFLE));
end;

function TWinamp.GetRepeat: Boolean;
begin
  Result:=False;
  If GetVersion<$2400 then exit;
  Result:=Boolean(SendMessage(hwnd_winamp,WM_USER,0,WINAMP_IPC_GET_REPEAT));
end;

function TWinamp.GetPlaylistEditor: Boolean;
var
  hwnd_pl: HWND;
begin
  Result:=False;
  hwnd_pl:=FindWindow(nil,'Winamp Playlist Editor');
  if hwnd_pl=0 then exit;
  Result:=IsWindowVisible(hwnd_pl);
end;

function TWinamp.GetEqualizer: Boolean;
var
  hwnd_eq: HWND;
begin
  Result:=False;
  hwnd_eq:=FindWindow(nil,'Winamp Equalizer');
  if hwnd_eq=0 then exit;
  Result:=IsWindowVisible(hwnd_eq);
end;

procedure TWinamp.SetPlaylistEditor(AStatus: Boolean);
begin
  if AStatus<>GetPlayListEditor then OpenPlayList;
end;

procedure TWinamp.SetEqualizer(AStatus: Boolean);
begin
  if AStatus<>GetEqualizer then OpenEQ;
end;

procedure TWinamp.SetWAVisible(AStatus: Boolean);
begin
  if AStatus=True then //<>GetWAVisible then MakeVisible;
    ShowWindowAsync(hwnd_winamp,SW_SHOW)
  else
    ShowWindowAsync(hwnd_winamp,SW_HIDE);
  FVisible:=AStatus;
end;

function TWinamp.GetWAVisible: Boolean;
begin
  Result:=IsWindowVisible(hwnd_winamp);
end;

//
//version 1.30
function TWinamp.GetFileInfo: stFileInfo;
begin
  If GetVersion<$2005 then exit;
  Result.Samplerate:=SendMessage(hwnd_winamp,WM_USER,0,WINAMP_IPC_GETINFO);
  Result.Bitrate:=SendMessage(hwnd_winamp,WM_USER,1,WINAMP_IPC_GETINFO);
  Result.Channels:=SendMessage(hwnd_winamp,WM_USER,2,WINAMP_IPC_GETINFO);
end;

function TWinamp.GetEQStatus: stEQStatus;
begin
  If GetVersion<$2400 then exit;
  Result.EQ60Hz:=SendMessage(hwnd_winamp,WM_USER,0,WINAMP_IPC_GETEQDATA);
  Result.EQ170Hz:=SendMessage(hwnd_winamp,WM_USER,1,WINAMP_IPC_GETEQDATA);
  Result.EQ310Hz:=SendMessage(hwnd_winamp,WM_USER,2,WINAMP_IPC_GETEQDATA);
  Result.EQ600Hz:=SendMessage(hwnd_winamp,WM_USER,3,WINAMP_IPC_GETEQDATA);
  Result.EQ1KHz:=SendMessage(hwnd_winamp,WM_USER,4,WINAMP_IPC_GETEQDATA);
  Result.EQ3KHz:=SendMessage(hwnd_winamp,WM_USER,5,WINAMP_IPC_GETEQDATA);
  Result.EQ6KHz:=SendMessage(hwnd_winamp,WM_USER,6,WINAMP_IPC_GETEQDATA);
  Result.EQ12KHz:=SendMessage(hwnd_winamp,WM_USER,7,WINAMP_IPC_GETEQDATA);
  Result.EQ14KHz:=SendMessage(hwnd_winamp,WM_USER,8,WINAMP_IPC_GETEQDATA);
  Result.EQ16KHz:=SendMessage(hwnd_winamp,WM_USER,9,WINAMP_IPC_GETEQDATA);
  Result.EQPreamp:=SendMessage(hwnd_winamp,WM_USER,10,WINAMP_IPC_GETEQDATA);
  Result.EQEnabled:=Boolean(SendMessage(hwnd_winamp,WM_USER,0,WINAMP_IPC_GETEQDATA));
  Result.EQAutoload:=Boolean(SendMessage(hwnd_winamp,WM_USER,0,WINAMP_IPC_GETEQDATA));
end;

procedure TWinamp.SetEQStatus(Value: stEQStatus);
begin
  If GetVersion<$2400 then exit;
  SendMessage(hwnd_winamp,WM_USER,0,WINAMP_IPC_GETEQDATA);
  SendMessage(hwnd_winamp,WM_USER,Value.EQ60Hz,WINAMP_IPC_SETEQDATA);
  SendMessage(hwnd_winamp,WM_USER,1,WINAMP_IPC_GETEQDATA);
  SendMessage(hwnd_winamp,WM_USER,Value.EQ170Hz,WINAMP_IPC_SETEQDATA);
  SendMessage(hwnd_winamp,WM_USER,2,WINAMP_IPC_GETEQDATA);
  SendMessage(hwnd_winamp,WM_USER,Value.EQ310Hz,WINAMP_IPC_SETEQDATA);
  SendMessage(hwnd_winamp,WM_USER,3,WINAMP_IPC_GETEQDATA);
  SendMessage(hwnd_winamp,WM_USER,Value.EQ600Hz,WINAMP_IPC_SETEQDATA);
  SendMessage(hwnd_winamp,WM_USER,4,WINAMP_IPC_GETEQDATA);
  SendMessage(hwnd_winamp,WM_USER,Value.EQ1KHz,WINAMP_IPC_SETEQDATA);
  SendMessage(hwnd_winamp,WM_USER,5,WINAMP_IPC_GETEQDATA);
  SendMessage(hwnd_winamp,WM_USER,Value.EQ3KHz,WINAMP_IPC_SETEQDATA);
  SendMessage(hwnd_winamp,WM_USER,6,WINAMP_IPC_GETEQDATA);
  SendMessage(hwnd_winamp,WM_USER,Value.EQ6KHz,WINAMP_IPC_SETEQDATA);
  SendMessage(hwnd_winamp,WM_USER,7,WINAMP_IPC_GETEQDATA);
  SendMessage(hwnd_winamp,WM_USER,Value.EQ12KHz,WINAMP_IPC_SETEQDATA);
  SendMessage(hwnd_winamp,WM_USER,8,WINAMP_IPC_GETEQDATA);
  SendMessage(hwnd_winamp,WM_USER,Value.EQ14KHz,WINAMP_IPC_SETEQDATA);
  SendMessage(hwnd_winamp,WM_USER,9,WINAMP_IPC_GETEQDATA);
  SendMessage(hwnd_winamp,WM_USER,Value.EQ16KHz,WINAMP_IPC_SETEQDATA);
  SendMessage(hwnd_winamp,WM_USER,10,WINAMP_IPC_GETEQDATA);
  SendMessage(hwnd_winamp,WM_USER,Value.EQPreamp,WINAMP_IPC_SETEQDATA);
  SendMessage(hwnd_winamp,WM_USER,11,WINAMP_IPC_GETEQDATA);
  SendMessage(hwnd_winamp,WM_USER,ord(Value.EQEnabled),WINAMP_IPC_SETEQDATA);
  SendMessage(hwnd_winamp,WM_USER,12,WINAMP_IPC_GETEQDATA);
  SendMessage(hwnd_winamp,WM_USER,ord(Value.EQAutoload),WINAMP_IPC_SETEQDATA);
end;
//
//temp
procedure TWinamp.ID3Tag;
begin
 SetForegroundWindow(hwnd_winamp);
 keybd_event( VK_MENU, MapVirtualkey( VK_MENU, 0 ), 0, 0);
 keybd_event( Ord('3'), MapVirtualKey( Ord('3'),0), 0, 0);
 keybd_event( Ord('3'), MapVirtualKey( Ord('3'),0), KEYEVENTF_KEYUP, 0);
 keybd_event( VK_MENU, MapVirtualkey( VK_MENU, 0 ), KEYEVENTF_KEYUP, 0);
//   SendMessage(hwnd_winamp,WM_SYSKEYDOWN,51,$20000000);
end;
//

procedure TWinamp.TimerExpired(Sender: TObject);
var
  stat: TWinampStatus;
  tmeq: stEQStatus;
begin
   If not IsWindow(hwnd_winamp) then
   begin
     CloseWinamp;
     If Assigned(FOnExit) then FOnExit(self);
   end;
//version 1.35
   tmeq:=GetEQStatus;
   if (eqst.EQ60Hz<>tmeq.EQ60Hz) or
      (eqst.EQ170Hz<>tmeq.EQ170Hz) or
      (eqst.EQ310Hz<>tmeq.EQ310Hz) or
      (eqst.EQ600Hz<>tmeq.EQ600Hz) or
      (eqst.EQ1KHz<>tmeq.EQ1KHz) or
      (eqst.EQ3KHz<>tmeq.EQ3KHz) or
      (eqst.EQ6KHz<>tmeq.EQ6KHz) or
      (eqst.EQ12KHz<>tmeq.EQ12KHz) or
      (eqst.EQ14KHz<>tmeq.EQ14KHz) or
      (eqst.EQ16KHz<>tmeq.EQ16KHz) or
      (eqst.EQPreamp<>tmeq.EQPreamp) or
      (eqst.EQEnabled<>tmeq.EQEnabled) or
      (eqst.EQAutoload<>tmeq.EQAutoload) then
   begin
     eqst:=tmeq;
     If Assigned(FOnEQChange) then FOnEQChange(eqst);
   end;
//
   FVisible:=GetWAVisible;
   stat:=GetStatus;
   if Stat<>Status then
   begin
     Status:=Stat;
     if Status=WAStop then
     begin
       if Assigned(FOnStop) then FOnStop(Self);
     end
     else if Status=WAPlaying then
     begin
       if Assigned(FOnStart) then FOnStart(Self);
     end
     else if Status=WAPause then
     begin
       if Assigned(FOnPause) then FOnPause(Self);
     end;
   end;
end;

function TWinamp.SupportFormats: PChar;
type
  TInDll = function: pIn_mod; stdcall;
var
  handle: THandle;
  func: TInDll;
  str: PIn_mod;
  i,res: integer;
  ee: Boolean;
  ss,ss2: string;
  SR: TSearchRec;
  p,ss1: PChar;
  PluginsDir: String;
  ext,for_res,All_ext: string;
begin
  If not FileExists(FPath2Winamp) then
  begin
    Result:=nil;
  end;
  for_res:='';
  all_ext:='';
  PluginsDir:=ExtractFilePath(FPath2Winamp)+'Plugins\';
  res:=FindFirst(PluginsDir+'in_*.dll',faAnyFile,SR);
  while res=0 do
  begin
  handle:=LoadLibrary(PChar(PluginsDir+SR.Name));
  try
    @func:=GetProcAddress(handle,'winampGetInModule2');
    str:=func;
    ee:=False;
    ss:='';
    for i:=0 to 1024 do
    begin
      If str.FileExtensions[i]=#0 then
      begin
       if ss='' then break;
       if ee=False then
       begin
         if UpperCase(ss)='ACK' then
           ss:='MP1;MP2;MP3';
         ss2:='';
         p:=StrPos(PChar(ss),';');
         While p<>nil do
         begin
           ss1:='';
           ss2:=ss2+'*.'+strlcopy(ss1,PChar(ss),p-PChar(ss))+';';
           ss:=string(p+1);
           p:=StrPos(PChar(ss),';');
         end;
         if ss2<>'' then
         begin
           ss2:=ss2+'*.'+ss;
           ss:=ss2;
         end
         else
           ss:='*.'+ss;
         if All_ext<>'' then all_ext:=all_ext+';';
         all_ext:=all_ext+ss;
         ext:=ss;
         ss:='';
         ee:=True;
       end
       else
       begin
         If UpperCase(ss)='DOH' then
           ss:='MPEG Audio Files (*.MP1;*.MP2;*.MP3)';
         if for_res<>'' then for_res:=for_res+'|';
         for_res:=for_res+ss+'|'+ext;
         ss:='';
         ext:='';
         ee:=False;
       end;
      end
      else ss:=ss+str.FileExtensions[i];
    end;
  except
  end;
  FreeLibrary(handle);
  res:=FindNext(SR);
  end;
  FindClose(SR);
  Result:=PChar('All supported types|'+all_ext+'|'+for_res+#0);
end;
{ TAboutProperty }

Procedure TAboutProperty.Edit;
var
  AboutDlg : TWAAbout;
begin
  AboutDlg:= TWAAbout.Create(Application);
  Try
    AboutDlg.ShowModal;
  Finally
    AboutDlg.Free;
  end;
end;

Function TAboutProperty.GetAttributes: TPropertyAttributes;
begin
  Result := [paDialog, paReadOnly];
end;


{ TWAPathProperty }

procedure TWAPathProperty.Edit;
var
  WAFileOpen: TOpenDialog;
begin
  WAFileOpen:= TOpenDialog.Create(Application);
  WAFileOpen.fileName:= GetValue;
  WAFileOpen.filter:= 'WinAmp player|winamp.exe';
  WAFileOpen.helpContext:= 0;
  WAFileOpen.options:= WAFileOpen.Options + [ofPathMustExist, ofFileMustExist];
  Try
	 If WAFileOpen.Execute Then SetValue(WAFileOpen.fileName);
  Finally
	 WAFileOpen.Free;
  end;
end;

function TWAPathProperty.GetAttributes: TPropertyAttributes;
begin
  Result := [paDialog, paRevertable];
end;

//version 1.35
{ TWAFileProperty }

procedure TWAFileProperty.Edit;
var
  WAFileOpen: TOpenDialog;
begin
  WAFileOpen:= TOpenDialog.Create(Application);
  WAFileOpen.fileName:= GetValue;
  WAFileOpen.filter:= 'Music (*.mp3,*.wav)|*.mp3;*.wav|All Files|*.*';
  WAFileOpen.helpContext:= 0;
  WAFileOpen.options:= WAFileOpen.Options + [ofPathMustExist, ofFileMustExist];
  Try
	 If WAFileOpen.Execute Then SetValue(WAFileOpen.fileName);
  Finally
	 WAFileOpen.Free;
  end;
end;

function TWAFileProperty.GetAttributes: TPropertyAttributes;
begin
  Result := [paDialog, paRevertable];
end;
//

Procedure Register;
begin
  RegisterComponents('AMSoft', [TWinamp]);
  RegisterPropertyEditor(TypeInfo(string), TWinamp, 'About', TAboutProperty);
  RegisterPropertyEditor(TypeInfo(string), TWinamp, 'PathToWinAmp', TWAPathProperty);
//version 1.35
  RegisterPropertyEditor(TypeInfo(string), TWinamp, 'FileName', TWAFileProperty);
//
end;


end.

